(*----------------------------------------------------------------------------*)
(* Demo for the internationalization unit langsup.pas.                        *)
(* Author: Joachim Pimiskern, 2004                                            *)
(* Status: Freeware. Use and/or modify it at your own risk.                   *)
(*----------------------------------------------------------------------------*)
unit demomain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ExtCtrls,
  langsup;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ButtonFirst: TButton;
    BitBtnSecond: TBitBtn;
    Label1: TLabel;
    ButtonLearn: TButton;
    ComboBox1: TComboBox;
    Bevel1: TBevel;
    ButtonClose: TButton;
    ButtonLanguages: TButton;
    ButtonCount: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ButtonLearnClick(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonLanguagesClick(Sender: TObject);
    procedure ButtonCountClick(Sender: TObject);
  private
    language: TLangSup;
    count   : integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;

implementation
uses
   addlang;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  language := TLangSup.Create('Deutsch');
  language.LoadFromFile(ExtractFilePath(Application.Exename) + 'language.txt');
  language.SetLanguage('Deutsch');
  language.SetContext('Demo Main');
  language.SetCaptions(self);
  count := 0;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  language.SaveToFile(ExtractFilePath(Application.Exename) + 'language.txt');
  language.Free;
end;

procedure TForm1.ButtonLearnClick(Sender: TObject);
var FormAddLanguage: TFormAddLanguage;
begin
  FormAddLanguage := TFormAddLanguage.Create(nil);
  try
    FormAddLanguage.Language := self.language;
    FormAddLanguage.ShowModal;
  finally
    FormAddLanguage.Free;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
begin
  language.SetLanguage(Combobox1.Text);
  language.SetCaptions(self);
end;

procedure TForm1.ButtonCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.ButtonLanguagesClick(Sender: TObject);
var sl: TStringList;
    s : string;
    i : integer;
begin
  sl := TStringList.Create;
  try
    language.GetLanguages(sl);
    s := '';
    for i := 0 to sl.Count-1 do
        s := s + sl[i]+#13#10;
    ShowMessage(s);
  finally
    sl.Free;
  end;
end;

procedure TForm1.ButtonCountClick(Sender: TObject);
var s: string;
begin
  inc(count);
  s := 'Dieser Knopf wurde %d mal gedrckt';
  s := language.get(s);
  ShowMessage(Format(s,[count]));
end;

end.
